标签: 可持久化

[国家集训队]数颜色 题解

[国家集训队]数颜色 题解

题目地址:洛谷:【P1903】[国家集训队]数颜色 – 洛谷、BZOJ:Problem 2120. — 数颜色

题目描述

墨墨购买了一套N支彩色画笔(其中有些颜色可能相同),摆成一排,你需要回答墨墨的提问。墨墨会向你发布如下指令:

  1. Q L R代表询问你从第L支画笔到第R支画笔中共有几种不同颜色的画笔。
  2. R P Col 把第P支画笔替换为颜色Col。

为了满足墨墨的要求,你知道你需要干什么了吗?

题意简述

给一个颜色数组,每个位置有一个颜色,两种操作:

  1. 改变某位置颜色
  2. 查询区间颜色数

输入输出格式

输入格式:
第1行两个整数N,M,分别代表初始画笔的数量以及墨墨会做的事情的个数。
第2行N个整数,分别代表初始画笔排中第i支画笔的颜色。
第3行到第2+M行,每行分别代表墨墨会做的一件事情,格式见题干部分。

输出格式:
对于每一个Query的询问,你需要在对应的行中给出一个数字,代表第L支画笔到第R支画笔中共有几种不同颜色的画笔。

输入输出样例

输入样例#1:

6 5
1 2 3 4 5 5
Q 1 4
Q 2 6
R 1 2
Q 1 4
Q 2 6

输出样例#1:

4
4
3
4

说明

对于100%的数据,N≤50000,M≤50000,所有的输入数据中出现的所有整数均大于等于1且不超过10^6。
本题可能轻微卡常数

题解

我们可以求出每个位置的pre值,表示该位置颜色在该位置之前的最后一次出现位置。如果该位置之前没有出现过这种颜色了,则规定pre值为0。这个问题就可以转化成一个区间内查询pre值小于区间左端点数量的问题,显然可以用树状数组套主席树这样的形式来维护。
至于修改,我们可以用set维护每个颜色的出现位置,这样就可以利用lower_bound找前驱后继,从而维护线段树中的信息。
总复杂度O(n \log^2 n),不过这种写法跑的特别慢,还好卡进去了。

代码

// Code by KSkun, 2018/5
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>
#include <set>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) 
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1;
    register char c = fgc();
    while(!isdigit(c)) {
        if(c == '-') neg = -1;
        c = fgc();
    }
    while(isdigit(c)) {
        res = (res << 1) + (res << 3) + c - '0';
        c = fgc();
    }
    return res * neg;
}

inline bool isop(char c) {
    return c == 'Q' || c == 'R';
}

inline char readop() {
    char c;
    while(!isop(c = fgc())) {}
    return c;
}

const int MAXN = 50005;

struct Node {
    int lch, rch, val;
} tr[MAXN * 200];
int rt[MAXN], tot;

int sta[MAXN], stop;

inline int newnode() {
    if(!stop) return ++tot;
    int p = sta[--stop];
    memset(tr + p, 0, sizeof(Node));
    return p;
}

inline void delnode(int p) {
    if(!p) return;
    sta[stop++] = p;
}

inline void insert(int &o, int l, int r, int x) {
    int p = newnode(); tr[p] = tr[o]; delnode(o); o = p;
    tr[o].val++;
    if(l == r) return;
    int mid = (l + r) >> 1;
    if(x <= mid) insert(tr[o].lch, l, mid, x);
    else insert(tr[o].rch, mid + 1, r, x);
}

inline void erase(int &o, int l, int r, int x) {
    int p = newnode(); tr[p] = tr[o]; delnode(o); o = p;
    tr[o].val--;
    if(l == r) return;
    int mid = (l + r) >> 1;
    if(x <= mid) erase(tr[o].lch, l, mid, x);
    else erase(tr[o].rch, mid + 1, r, x);
}

inline int query(int o, int l, int r, int x) {
    if(l == r) return 0;
    int mid = (l + r) >> 1;
    if(x <= mid) return query(tr[o].lch, l, mid, x);
    else return tr[tr[o].lch].val + query(tr[o].rch, mid + 1, r, x);
}

int n, m;

inline int lowbit(int x) {
    return x & -x;
}

inline void insert(int x, int v) {
    for(int i = x; i <= n; i += lowbit(i)) {
        insert(rt[i], 0, 1000000, v);
    }
}

inline void erase(int x, int v) {
    for(int i = x; i <= n; i += lowbit(i)) {
        erase(rt[i], 0, 1000000, v);
    }
}

inline int query(int x, int v) {
    int res = 0;
    for(int i = x; i; i -= lowbit(i)) {
        res += query(rt[i], 0, 1000000, v);
    }
    return res;
}

std::set<int> col[1000005];
int col2[MAXN];

char op; int x, y;

int main() {
    n = readint(); m = readint();
    for(int i = 1; i <= 1000000; i++) {
        col[i].insert(0);
    }
    for(int i = 1; i <= n; i++) {
        x = readint();
        col[x].insert(i); col2[i] = x;
        if(col[x].empty()) col[x].insert(0);
        std::set<int>::iterator it = col[x].lower_bound(i);
        insert(i, *--it);
    }
    while(m--) {
        op = readop(); x = readint(); y = readint();
        if(op == 'Q') {
            printf("%d\n", query(y, x) - query(x - 1, x));
        } else {
            std::set<int>::iterator it = col[col2[x]].lower_bound(x), 
                itp = --it, itn = ++++it; --it;
            erase(x, *itp); 
            if(itn != col[col2[x]].end()) { 
                erase(*itn, x); insert(*itn, *itp);
            } 
            col[col2[x]].erase(it); col2[x] = y;
            col[col2[x]].insert(x); it = col[col2[x]].lower_bound(x); 
            itp = --it; itn = ++++it; --it;
            insert(x, *itp); 
            if(itn != col[col2[x]].end()) {
                erase(*itn, *itp); insert(*itn, x);
            }
        }
    }
    return 0;
}
[CQOI2011]动态逆序对 题解

[CQOI2011]动态逆序对 题解

题目地址:洛谷:【P3157】[CQOI2011]动态逆序对 – 洛谷、BZOJ:Problem 3295. — [Cqoi2011]动态逆序对

题目描述

对于序列A,它的逆序对数定义为满足i<j,且Ai>Aj的数对(i,j)的个数。给1到n的一个排列,按照某种顺序依次删除m个元素,你的任务是在每次删除一个元素之前统计整个序列的逆序对数。

输入输出格式

输入格式:
输入第一行包含两个整数n和m,即初始元素的个数和删除的元素个数。以下n行每行包含一个1到n之间的正整数,即初始排列。以下m行每行一个正整数,依次为每次删除的元素。

输出格式:
输出包含m行,依次为删除每个元素之前,逆序对的个数。

输入输出样例

输入样例#1:

5 4
1
5
3
4
2
5
1
4
2

输出样例#1:

5
2
2
1

说明

N<=100000 M<=50000

题解

树套树(BIT套动态开点权值线段树)

考虑倒着插回去,插一个计算一次答案。关键在于,如果我们直接用主席树写这个,插回去的复杂度是O(n \log n)的,因为要对插入位置及以后的每个点更新信息。我们套一个BIT上去,令BIT的每个节点的权值线段树维护该节点覆盖范围内的数值分布情况。这样,每次插入在BIT上影响到的点是O(\log n)级别的,也就是说,总复杂度降为了O(\log^2 n)
由于我们不可能真的每个点开一棵线段树,空间O(n^2)不可接受,就需要用到动态开点和垃圾回收的手段来优化空间使用。优化后的空间是O(n \log^2 n)的。

CDQ分治

还没学。

代码

树套树

// Code by KSkun, 2018/5
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) 
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1;
    register char c = fgc();
    while(!isdigit(c)) {
        if(c == '-') neg = -1;
        c = fgc();
    }
    while(isdigit(c)) {
        res = (res << 1) + (res << 3) + c - '0';
        c = fgc();
    }
    return res * neg;
}

const int MAXN = 100005;

int n, m;

struct Node {
    int lch, rch, cnt;
} tr[MAXN * 90];
int rt[MAXN], tot;

int sta[MAXN * 90], stop;

inline void delnode(int p) {
    if(!p) return;
    sta[stop++] = p;
}

inline int newnode() {
    if(!stop) return ++tot;
    int p = sta[--stop];
    memset(tr + p, 0, sizeof(Node));
    return p;
}

inline void insert(int &o, int l, int r, int x) {
    int p = newnode(); tr[p] = tr[o]; delnode(o); o = p;
    tr[p].cnt++;
    if(l == r) return;
    int mid = (l + r) >> 1;
    if(x <= mid) insert(tr[o].lch, l, mid, x);
    else insert(tr[o].rch, mid + 1, r, x);
}

inline int querylar(int o, int l, int r, int x) {
    if(l == r) return 0;
    int mid = (l + r) >> 1;
    if(x <= mid) return tr[tr[o].rch].cnt + querylar(tr[o].lch, l, mid, x);
    else return querylar(tr[o].rch, mid + 1, r, x);
}

inline int querysma(int o, int l, int r, int x) {
    if(l == r) return 0;
    int mid = (l + r) >> 1;
    if(x <= mid) return querysma(tr[o].lch, l, mid, x);
    else return tr[tr[o].lch].cnt + querysma(tr[o].rch, mid + 1, r, x);
}

inline int lowbit(int x) {
    return x & -x;
}

inline void add(int x, int v) {
    for(int i = x; i <= n; i += lowbit(i)) {
        insert(rt[i], 1, n, v);
    }
}

inline int query(int x, int v) {
    int res = 0;
    for(int i = x; i; i -= lowbit(i)) res += querylar(rt[i], 1, n, v);
    for(int i = n; i; i -= lowbit(i)) res += querysma(rt[i], 1, n, v);
    for(int i = x; i; i -= lowbit(i)) res -= querysma(rt[i], 1, n, v);
    return res;
}

int a[MAXN], del[MAXN], idx[MAXN];
LL anss[MAXN];
bool isdel[MAXN];

int main() {
    n = readint(); m = readint();
    for(int i = 1; i <= n; i++) {
        a[i] = readint();
        idx[a[i]] = i;
    }
    for(int i = m; i; i--) {
        del[i] = readint();
        isdel[del[i]] = true;
    }
    LL ans = 0;
    for(int i = 1; i <= n; i++) {
        if(!isdel[a[i]]) {
            add(i, a[i]);
            ans += query(i, a[i]);
        }
    }
    for(int i = 1; i <= m; i++) {
        add(idx[del[i]], del[i]);
        ans += query(idx[del[i]], del[i]);
        anss[m - i + 1] = ans;
    }
    for(int i = 1; i <= m; i++) {
        printf("%lld\n", anss[i]);
    }
    return 0;
}

CDQ分治

[SPOJ-QTREE6]Query on a tree VI 题解

[SPOJ-QTREE6]Query on a tree VI 题解

题目地址:洛谷:【SP16549】QTREE6 – Query on a tree VI – 洛谷、SPOJ:SPOJ.com – Problem QTREE6

SPOJ QTREE系列:

题目描述

You are given a tree (an acyclic undirected connected graph) with n nodes. The tree nodes are numbered from 1 to n. Each node has a color, white or black. All the nodes are black initially. We will ask you to perform some instructions of the following form:

  • 0 u: ask for how many nodes are connected to u, two nodes are connected if all the node on the path from u to v (inclusive u and v) have the same color.
  • 1 u: toggle the color of u (that is, from black to white, or from white to black).

给一棵树,最初点全是黑色的,操作:1.询问到u路径颜色相同的点有多少个2.改变颜色

输入输出格式

输入格式:
The first line contains a number n that denotes the number of nodes in the tree (1 ≤ n ≤ 10^5). In each of the following n-1 lines, there will be two numbers (u, v) that describes an edge of the tree (1 ≤ u, v ≤ n). The next line contains a number m denoting number of operations we are going to process (1 ≤ m ≤ 10^5). Each of the following m lines describe an operation (t, u) as we mentioned above(0 ≤ t ≤ 1, 1 ≤ u ≤ n).

输出格式:
For each query operation, output the corresponding result.

输入输出样例

输入样例#1:

5
1 2
1 3
1 4
1 5
3
0 1
1 1
0 1

输出样例#1:

5
1

输入样例#2:

7
1 2
1 3
2 4
2 5
3 6
3 7
4
0 1
1 1
0 2
0 3

输出样例#2:

7
3
3

题解

参考资料:【Qtree】Query on a tree系列LCT解法 – CSDN博客
本题还是可以用边分……等等这题边分我做不动了,用的LCT。
我们考虑搞两棵LCT对应黑和白色的点构成的树。这样其实查询就变成了某一棵树上的子树大小查询。这个可以用子树信息LCT方便地维护。具体来说,就是统计一下跟当前点相连的轻边子树大小和Splay子树大小加起来。access的时候边合并Splay边更新轻边子树大小即可。
但是如果改变颜色的时候强行切边,有可能被菊花图卡掉。我们考虑把原树拉成一棵有根树,只切该点和父亲的边,这样,这棵LCT就满足所有儿子肯定同色,但是这个父亲可以跟儿子不同色这样的性质。我们在统计答案的时候找到子树根,然后看看子树根是否和儿子的颜色一致,不一致就取儿子的答案即可。
有一个小优化,可以DFS建树,把原树的边建成LCT上的轻边就好。

代码

// Code by KSkun, 2018/3
#include <cstdio>
#include <cstring>

#include <algorithm>

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}

inline int readint() {
    register int res = 0, neg = 1;
    char c = fgc();
    while(c < '0' || c > '9') {
        if(c == '-') neg = -1;
        c = fgc();
    }
    while(c >= '0' && c <= '9') {
        res = res * 10 + c - '0';
        c = fgc();
    }
    return res * neg;
}

const int MAXN = 100005, INF = 1e9;

struct Edge {
    int to, w, nxt;
} gra[MAXN << 1];
int head[MAXN], ecnt, fa[MAXN], col[MAXN];

inline void addedge(int u, int v, int w) {
    gra[ecnt] = Edge {v, w, head[u]}; head[u] = ecnt++;
}

struct LCT {
    struct LCTNode {
        int ch[2], fa, siz, s;
        bool rev;
    } lct[MAXN];

    inline bool isleft(int p) {
        return lct[lct[p].fa].ch[0] == p;
    }

    inline bool isroot(int p) {
        register int fa = lct[p].fa;
        return lct[fa].ch[0] != p && lct[fa].ch[1] != p;
    }

    inline void update(int p) {
        register int ls = lct[p].ch[0], rs = lct[p].ch[1];
        lct[p].siz = lct[p].s + lct[ls].siz + lct[rs].siz + 1;
    }

    inline void reverse(int p) {
        std::swap(lct[p].ch[0], lct[p].ch[1]);
        lct[p].rev ^= 1;
    }

    inline void pushdown(int p) {
        register int ls = lct[p].ch[0], rs = lct[p].ch[1];
        if(lct[p].rev) {
            if(ls) reverse(ls);
            if(rs) reverse(rs);
            lct[p].rev ^= 1;
        }
    }

    int sta[MAXN], stop;

    inline void pushto(int p) {
        stop = 0;
        while(!isroot(p)) {
            sta[stop++] = p;
            p = lct[p].fa;
        }
        pushdown(p);
        while(stop) {
            pushdown(sta[--stop]);
        }
    }

    inline void rotate(int p) {
        register bool t = !isleft(p); register int fa = lct[p].fa, ffa = lct[fa].fa;
        lct[p].fa = ffa; if(!isroot(fa)) lct[ffa].ch[!isleft(fa)] = p;
        lct[fa].ch[t] = lct[p].ch[!t]; lct[lct[fa].ch[t]].fa = fa;
        lct[p].ch[!t] = fa; lct[fa].fa = p;
        update(fa);
    }

    inline void splay(int p) {
        pushto(p);
        for(register int fa = lct[p].fa; !isroot(p); rotate(p), fa = lct[p].fa) {
            if(!isroot(fa)) rotate(isleft(fa) == isleft(p) ? fa : p);
        }
        update(p);
    }

    inline void access(int p) {
        for(register int q = 0; p; q = p, p = lct[p].fa) {
            splay(p);
            if(lct[p].ch[1]) lct[p].s += lct[lct[p].ch[1]].siz;
            if(q) lct[p].s -= lct[q].siz;
            lct[p].ch[1] = q;
            update(p);
        }
    }

    inline void makert(int p) {
        access(p);
        splay(p);
        reverse(p);
    }

    inline int findrt(int p) {
        access(p);
        splay(p);
        while(lct[p].ch[0]) p = lct[p].ch[0];
        return p;
    }

    inline void link(int u) {
        access(fa[u]);
        splay(fa[u]);
        splay(u);
        lct[fa[u]].ch[1] = u;
        lct[u].fa = fa[u];
        update(fa[u]);
    }

    inline void cut(int u) {
        access(u);
        splay(u);
        lct[u].ch[0] = lct[lct[u].ch[0]].fa = 0;
        update(u);
    }

    inline int query(int u) {
        int c = col[u];
        u = findrt(u);
        splay(u);
        return col[u] == c ? lct[u].siz : lct[lct[u].ch[1]].siz;
    }
} L[2];

inline void dfs(int u, int f) {
    for(int i = head[u]; ~i; i = gra[i].nxt) {
        int v = gra[i].to;
        if(v == f) continue;
        fa[v] = L[0].lct[v].fa = u;
        dfs(v, u);
        L[0].lct[u].s += L[0].lct[v].siz;
    }
    L[0].update(u);
}

int n, q, ut, vt, op;

int main() {
    memset(head, -1, sizeof(head));
    n = readint();
    for(int i = 1; i < n; i++) {
        ut = readint(); vt = readint();
        addedge(ut, vt, 1);
        addedge(vt, ut, 1);
    }
    dfs(1, 0);
    q = readint();
    while(q--) {
        op = readint(); ut = readint();
        if(!op) {
            printf("%d\n", L[col[ut]].query(ut));
        } else {
            if(fa[ut]) {
                L[col[ut]].cut(ut);
                L[col[ut] ^ 1].link(ut);
            }
            col[ut] ^= 1;
        }
    }
    return 0;
}